
#ifndef _JAM_PARSE_HPP_
#define _JAM_PARSE_HPP_


#include "Lists.hpp"

/*
 * Copyright 1993, 2000 Christopher Seiwald.
 *
 * This file is part of Jam - see jam.c for Copyright information.
 */

/*
 * parse.h - make and destroy parse trees as driven by the parser
 */

/*
 * parse tree node
 */

namespace Jam
{
	class Parse
	{
	public:
		Parse( 
			List 	*(*func)( Parse *p, LOL *args ),
			Parse	*left,
			Parse	*right,
			Parse	*third,
			const char	*string,
			const char	*string1,
			const int	num_ );

		void AddRef(void);
		void Release(void);

		static void 	parse_file( const char *f );
		static void 	parse_save( Parse *p );

	private:
		~Parse(void);

	public:
		List	*(*func)( Parse *p, LOL *args );
		Parse	*left;
		Parse	*right;
		Parse	*third;
		const char	*string;
		const char	*string1;
		const int	num;

	private:
		int	refs;

		static Parse* yypsave;
	} ;
}


#endif _JAM_PARSE_HPP_